Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.sql
Class DBDictionaryFactory

    java.lang.Object
      org.apache.openjpa.jdbc.sql.DBDictionaryFactory

    public class DBDictionaryFactory

extends Object

Factory class to instantiate a dictionary. It will use the following heuristic:

- Check to see if there is a DictionaryClass property, and if so, use that to instantiate the dictionary.
- Check the URL in the JDBCConfiguration against a list of pre-defined URLs for various dictionaries.
- Check the driver in the JDBCConfiguration against a list of known patterns.
- Acquire a connection and check its database metadata.
- Return an instance of the generic DBDictionary.

Author:
  Marc Prud'hommeaux

Constructor Summary
`DBDictionaryFactory()`

Method Summary
`static DBDictionary` | `calculateDBDictionary(JDBCConfiguration conf, String url, String driver, String props)` Attempt to create the dictionary from the given connection URL and driver name, either or both of which may be null.
`(package private) static String` | `getProtocol(String url)`
`static DBDictionary` | `newDBDictionary(JDBCConfiguration conf, DataSource ds, String props)` Create the dictionary using connection metadata to determine its type.
`static DBDictionary` | `newDBDictionary(JDBCConfiguration conf, String dclass, String props)` Create the dictionary for the given class name and properties.
`static String` | `toString(DatabaseMetaData meta)` Return a string containing all the property values of the given database metadata.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DBDictionaryFactory

    public DBDictionaryFactory()

Method Detail

### newDBDictionary

    public static DBDictionary newDBDictionary(JDBCConfiguration conf,
                                               String dclass,
                                               String props)

  Create the dictionary for the given class name and properties.

### calculateDBDictionary

    public static DBDictionary calculateDBDictionary(JDBCConfiguration conf,
                                                     String url,
                                                     String driver,
                                                     String props)

  Attempt to create the dictionary from the given connection URL and driver name, either or both of which may be null. If the dictionary cannot be calculated, returns null.

### newDBDictionary

    public static DBDictionary newDBDictionary(JDBCConfiguration conf,
                                               DataSource ds,
                                               String props)

  Create the dictionary using connection metadata to determine its type.

### getProtocol

    static String getProtocol(String url)

### toString

    public static String toString(DatabaseMetaData meta)
                           throws SQLException

  Return a string containing all the property values of the given database metadata.

  Throws:
    `SQLException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.